#include <bits/stdc++.h>

using namespace std;

int n,k;
int cntp[1000005];
int cntn[1000005];

int main() 
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);
    
    cin >> n >> k;
    
    for(int i=1;i<=n;i++)
    {
        int x;
        cin >> x;
        if(x >= 0) cntp[x]++;
        else cntn[-x]++;
    }
    
    vector<int> res;
    if(cntp[0]>=k) res.push_back(0);
    for(int i=1;i<=1000000;i++)
    {
        if(cntp[i]>=k) res.push_back(i);
        if(cntn[i]>=k) res.push_back(-i);
    }
    
    cout << res.size() << "\n";
    
    for(int x : res) cout << x << " ";
    
    return 0;
}